
#include <stdlib.h>
#include <string.h>
#include "interface.h"
#include "reg.h"

void list_uniq_add( char **list, int max, char *str )
{ int i,j;
	for(i=0;i<max && list[i]!=NULL;i++)
	{	if( !strcmp(list[i],str) )
		{	free(list[i]);
			for(j=i+1;j<max && list[j]!=NULL;)
				list[i++]=list[j++];
			list[i]=NULL;
			break;
		}
	}
	if( i>=max )
	{	i=0;
		free(list[i]);
		for(j=i+1;j<max && list[j]!=NULL;)
			list[i++]=list[j++];
		list[i]=NULL;
	}
	list[i]=str;
}

char *tab_list[MAX_TAB_LIST];
char *tac_list[MAX_TAB_LIST];
char *cmd_list[MAX_TAB_LIST];

void tab_add( char *str )
{ char *s;
  	s=reg_subst(str,"\\[[0-9]+(;[0-9]+)*m","","g");
	talker_tab_add(s);
	free(s);
}

void tab_add_kb( char *str )
{ int i;
  char *s;
	if( str[0]=='.' )
	{	i=1;
		while(str[i]!=0 && str[i]!=' ')		i++;
		while(str[i]==' ')			i++;
		while(str[i]!=0 && str[i]!=' ')		i++;
		if( (s=malloc(i+1))!=NULL )
		{	strncpy(s,str,i);
			s[i]=0;
			list_uniq_add(cmd_list,MAX_TAB_LIST,s);
		}
		talker_tab_add_kb(str);
	}
}

int tab_do( char *s, int pos, int maxlen )
{ char *p;
  int n,m,c;
  static int l_pos=0,l_n=0,l_m=0,i;
  char **list;
	if( pos>=0 )
	{	p=s+pos;
		while( p>s && *(p-1)!=' ' )	p--;
		n=0;
		while( p[n]!=0 && p[n]!=' ' && p-s+n<pos )	n++;
		m=n;
		l_pos=pos;
		l_n=n;
		l_m=m;
		i=MAX_TAB_LIST;
		c=0;
	}
	else
	{	pos=l_pos;
		p=s+l_pos;
		while( p>s && *(p-1)!=' ' )	p--;
		n=l_n;
		m=l_m;
		c=1;
	}
	if( pos==0 )			list=tac_list;
	else if( n>0 && *p=='.' )	list=cmd_list;
	else				list=tab_list;
Next:	for(i=i-1;i>=0;i--)
	{	if( list[i]!=NULL )
		{	if( !strncasecmp(p,list[i],n) && strlen(s)-n+strlen(list[i])+1<maxlen )
			{	memmove(p+strlen(list[i])+1,p+m,strlen(p)-m+1);
				memcpy(p,list[i],strlen(list[i]));
				p[strlen(list[i])]=' ';
				l_m=strlen(list[i])+1;
				n=p-s+strlen(list[i])+1;
				return(n);
			}
		}
	}
	if( c )
	{	i=MAX_TAB_LIST;
		c=0;
		goto Next;
	}
	return(pos);
}

